from avcl import avcl
import SocketServer, BaseHTTPServer
import soaplib
import sys

class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):

    def do_POST(self):
        try:
	    # get arguments
            data = self.rfile.read(int(self.headers["content-length"]))
            method, params = soaplib.loads(data)

	    # generate response
	    try:
		response = self.call(method, params)
	    except:
		# report exception back to server
		response = soaplib.dumps(
		    soaplib.Fault(1, "%s:%s" % (sys.exc_type, sys.exc_value))
		    )
		status = 500
	    else:
		response = soaplib.dumps(
		    soaplib.Response(method, None, response), 1
		    )
		status = 200
        except:
	    # internal error, report as HTTP server error
	    self.send_response(500)
	    self.end_headers()
	else:
	    # got a valid SOAP response
	    self.send_response(status)
	    self.send_header("Content-type", "text/xml")
	    self.send_header("Content-length", str(len(response)))
	    self.end_headers()
	    self.wfile.write(response)

	    # shut down the connection (from Skip Montanaro)
	    self.wfile.flush()
	    self.connection.shutdown(1)

    def call(self, method, params):
        print "CALL", method, params
        #Hier anpassen
        if method == "jobfile":
            print "Job: %s" % params[0]
            av = avcl()
            av.readJob(params[0])
            av.sendJob()
            av.receiveResult()
            return (len(av.result),av.result)
        if method == "jobstring":
            print "Job: %s" % params[0]
            av = avcl()
            av.job = params[0]
            av.sendJob()
            av.receiveResult()
            return (len(av.result),av.result)
    	if method == "quit":
    	    import os
    	    os._exit(1) # may cause socket errors on the client site
    	if method == "exception":
    	    raise TypeError, "some python exception"
        return params # Einfaches Echo

if __name__ == "__main__":
    host = "localhost"
    port = 8001
    server = SocketServer.TCPServer((host, port), RequestHandler)
    print "Avanti-cl SOAP-Server running at: %s:%s" % (host, port)
    server.serve_forever()

